#pragma once

#include <UIMLView.h>

class UnshapedRecipieElement : public Framework::UIMLElement
{
public:
    UnshapedRecipieElement();
    //! prüft, ob dieses UIML Element für ein bestimmtes xml Element zuständig
    //! ist
    bool isApplicableFor(Framework::XML::Element& element) override;
    //! erstellt eine neue Drawable zu einem gegebenen xml Element
    Framework::Drawable* parseElement(Framework::XML::Element& element,
        Framework::UIMLContainer& generalFactory) override;
    bool updateElement(Framework::XML::Element& element,
        Framework::Drawable& z,
        Framework::UIMLContainer& generalFactory) override;
    //! wendet die layout parameter zu einer Drawable an
    void layout(Framework::XML::Element& element,
        Framework::Drawable& z,
        int pWidth,
        int pHeight,
        Framework::UIMLContainer& generalLayouter) override;
};

class UnshapedRecipie : public Framework::DrawableBackground
{
private:
    Framework::RCArray<Drawable> ingredients;
    Framework::RCArray<Drawable> outputs;

public:
    UnshapedRecipie();
    void addIngredient(Drawable* ingredient);
    void addOutput(Drawable* output);
    bool tick(double tickVal) override;
    void render(Framework::Image& rObj) override;
    void doMouseEvent(Framework::MouseEvent& me, bool userRet) override;
};